Index: /trunk/Cocoa/Pester/Source/BDAlias.h
===================================================================
--- /trunk/Cocoa/Pester/Source/BDAlias.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/BDAlias.h	(revision 53)
@@ -63,4 +63,6 @@
 - (BOOL)isEqual:(id)object;
 
+- (NSString *)displayNameWithKindString:(NSString **)outKindString;
+
 - (NSString *)fullPath;
 - (NSString *)fullPathRelativeToPath:(NSString *)relPath;
Index: /trunk/Cocoa/Pester/Source/BDAlias.m
===================================================================
--- /trunk/Cocoa/Pester/Source/BDAlias.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/BDAlias.m	(revision 53)
@@ -245,4 +245,25 @@
 }
 
+- (NSString *)displayNameWithKindString:(NSString **)outKindString;
+{
+    AliasHandle alias = [self alias];
+    FSRef ref;
+    Boolean wasChanged;
+    CFStringRef name;
+
+    if (alias == NULL) return nil;
+    if (FSResolveAlias(NULL, alias, &ref, &wasChanged) != noErr) return nil;
+
+    if (LSCopyDisplayNameForRef(&ref, &name) != noErr) return nil;
+    [(NSString *)name autorelease];
+
+    if (outKindString != NULL) {
+        if (LSCopyKindStringForRef(&ref, (CFStringRef *)outKindString) != noErr) return nil;
+        [*outKindString autorelease];
+    }
+
+    return (NSString *)name;
+}
+
 - (NSString *)fullPath
 {
Index: /trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib
===================================================================
--- /trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib	(revision 52)
+++ /trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/classes.nib	(revision 53)
@@ -17,4 +17,10 @@
         {CLASS = NJRIntegerFilter; LANGUAGE = ObjC; SUPERCLASS = NSNumberFormatter; }, 
         {
+            CLASS = NJRIntervalField; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {intervalUnits = NSPopUpButton; }; 
+            SUPERCLASS = NSTextField; 
+        }, 
+        {
             ACTIONS = {stopSoundPreview = id; }; 
             CLASS = NJRQTMediaPopUpButton; 
@@ -23,4 +29,5 @@
             SUPERCLASS = NSPopUpButton; 
         }, 
+        {CLASS = NJRUnfocusableMovieView; LANGUAGE = ObjC; SUPERCLASS = NSMovieView; }, 
         {
             ACTIONS = {stopVoicePreview = id; }; 
@@ -29,4 +36,5 @@
             SUPERCLASS = NSPopUpButton; 
         }, 
+        {CLASS = NSDisclosureButtonCell; LANGUAGE = ObjC; SUPERCLASS = NSButtonCell; }, 
         {CLASS = NSObject; LANGUAGE = ObjC; }, 
         {
@@ -35,4 +43,5 @@
                 doScriptChanged = id; 
                 doSpeakChanged = id; 
+                editAlertChanged = id; 
                 inAtChanged = id; 
                 playSoundChanged = id; 
@@ -45,8 +54,12 @@
             LANGUAGE = ObjC; 
             OUTLETS = {
+                alertTabs = NSTabView; 
+                alertView = NSTextField; 
                 bounceDockIcon = NSButton; 
+                cancelButton = NSButton; 
                 displayMessage = NSButtonCell; 
                 doScript = NSButtonCell; 
                 doSpeak = NSButtonCell; 
+                editAlert = NSButtonCell; 
                 inAtMatrix = NSMatrix; 
                 messageField = NSTextField; 
@@ -67,4 +80,5 @@
                 timeSummary = NSTextField; 
                 voice = NJRVoicePopUpButton; 
+                wakeUp = NSButtonCell; 
             }; 
             SUPERCLASS = NSWindowController; 
Index: /trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib
===================================================================
--- /trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib	(revision 52)
+++ /trunk/Cocoa/Pester/Source/English.lproj/MainMenu.nib/info.nib	(revision 53)
@@ -4,12 +4,12 @@
 <dict>
 	<key>IBDocumentLocation</key>
-	<string>73 38 356 240 0 0 1600 1178 </string>
+	<string>63 2 356 240 0 0 1280 832 </string>
 	<key>IBEditorPositions</key>
 	<dict>
 		<key>29</key>
-		<string>94 343 273 44 0 0 1600 1178 </string>
+		<string>130 241 273 44 0 0 1280 832 </string>
 	</dict>
 	<key>IBFramework Version</key>
-	<string>286.0</string>
+	<string>291.0</string>
 	<key>IBOpenObjects</key>
 	<array>
@@ -18,5 +18,5 @@
 	</array>
 	<key>IBSystem Version</key>
-	<string>6D52</string>
+	<string>6G30</string>
 	<key>IBUserGuides</key>
 	<dict>
@@ -25,8 +25,12 @@
 			<key>guideLocations</key>
 			<array>
-				<string>Horizontal:92.000000</string>
-				<string>Horizontal:148.000000</string>
-				<string>Horizontal:116.000000</string>
-				<string>Horizontal:64.000000</string>
+				<string>Horizontal:122.000000</string>
+				<string>Horizontal:178.000000</string>
+				<string>Horizontal:192.000000</string>
+				<string>Vertical:36.000000</string>
+				<string>Vertical:16.000000</string>
+				<string>Vertical:85.000000</string>
+				<string>Vertical:422.000000</string>
+				<string>Horizontal:151.000000</string>
 			</array>
 			<key>guidesLocked</key>
Index: /trunk/Cocoa/Pester/Source/English.lproj/Movie alert.nib/classes.nib
===================================================================
--- /trunk/Cocoa/Pester/Source/English.lproj/Movie alert.nib/classes.nib	(revision 52)
+++ /trunk/Cocoa/Pester/Source/English.lproj/Movie alert.nib/classes.nib	(revision 53)
@@ -9,5 +9,5 @@
             SUPERCLASS = NSWindowController; 
         }, 
-        {CLASS = java.lang.Object; LANGUAGE = Java; }
+        {CLASS = "java.lang.Object"; LANGUAGE = Java; }
     ); 
     IBVersion = 1; 
Index: /trunk/Cocoa/Pester/Source/English.lproj/Movie alert.nib/info.nib
===================================================================
--- /trunk/Cocoa/Pester/Source/English.lproj/Movie alert.nib/info.nib	(revision 52)
+++ /trunk/Cocoa/Pester/Source/English.lproj/Movie alert.nib/info.nib	(revision 53)
@@ -1,8 +1,8 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist SYSTEM "file://localhost/System/Library/DTDs/PropertyList.dtd">
-<plist version="0.9">
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
 <dict>
 	<key>IBFramework Version</key>
-	<string>263.2</string>
+	<string>291.0</string>
 	<key>IBOpenObjects</key>
 	<array>
@@ -10,5 +10,5 @@
 	</array>
 	<key>IBSystem Version</key>
-	<string>5S66</string>
+	<string>6G30</string>
 </dict>
 </plist>
Index: /trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/classes.nib
===================================================================
--- /trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/classes.nib	(revision 52)
+++ /trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/classes.nib	(revision 53)
@@ -2,9 +2,24 @@
     IBClasses = (
         {CLASS = FirstResponder; LANGUAGE = ObjC; SUPERCLASS = NSObject; }, 
+        {CLASS = NJRIntegerFilter; LANGUAGE = ObjC; SUPERCLASS = NSNumberFormatter; }, 
         {
-            ACTIONS = {close = id; }; 
+            CLASS = NJRIntervalField; 
+            LANGUAGE = ObjC; 
+            OUTLETS = {intervalUnits = NSPopUpButton; }; 
+            SUPERCLASS = NSTextField; 
+        }, 
+        {
+            ACTIONS = {close = id; snooze = id; stopRepeating = id; }; 
             CLASS = PSAlarmNotifierController; 
             LANGUAGE = ObjC; 
-            OUTLETS = {dateField = NSTextField; messageField = NSTextField; }; 
+            OUTLETS = {
+                dateField = NSTextField; 
+                intervalField = NSTextField; 
+                messageField = NSTextField; 
+                nextDateField = NSTextField; 
+                okButton = NSButton; 
+                snoozeButton = NSButton; 
+                snoozeIntervalField = NJRIntervalField; 
+            }; 
             SUPERCLASS = NSWindowController; 
         }
Index: /trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib
===================================================================
--- /trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib	(revision 52)
+++ /trunk/Cocoa/Pester/Source/English.lproj/Notifier.nib/info.nib	(revision 53)
@@ -1,10 +1,10 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist SYSTEM "file://localhost/System/Library/DTDs/PropertyList.dtd">
-<plist version="0.9">
+<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
 <dict>
 	<key>IBDocumentLocation</key>
-	<string>424 83 356 240 0 0 1280 832 </string>
+	<string>122 13 356 240 0 0 1280 832 </string>
 	<key>IBFramework Version</key>
-	<string>263.2</string>
+	<string>291.0</string>
 	<key>IBOpenObjects</key>
 	<array>
@@ -12,5 +12,21 @@
 	</array>
 	<key>IBSystem Version</key>
-	<string>5S66</string>
+	<string>6G30</string>
+	<key>IBUserGuides</key>
+	<dict>
+		<key>5</key>
+		<dict>
+			<key>guideLocations</key>
+			<array>
+				<string>Horizontal:87.000000</string>
+				<string>Horizontal:108.000000</string>
+				<string>Horizontal:66.000000</string>
+				<string>Vertical:92.000000</string>
+				<string>Horizontal:133.000000</string>
+			</array>
+			<key>guidesLocked</key>
+			<false/>
+		</dict>
+	</dict>
 </dict>
 </plist>
Index: /trunk/Cocoa/Pester/Source/NJRFSObjectSelector.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRFSObjectSelector.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRFSObjectSelector.m	(revision 53)
@@ -1,10 +1,18 @@
 #import "NJRFSObjectSelector.h"
 #import "NSImage-NJRExtensions.h"
+#import "NSString-NJRExtensions.h"
 #include <Carbon/Carbon.h>
 
+static NSImage *PopupTriangleImage = nil;
+static NSSize PopupTriangleSize;
+
 @implementation NJRFSObjectSelector
 
 - (void)_initSelector;
 {
+    if (PopupTriangleImage == nil) {
+        PopupTriangleImage = [[NSImage imageNamed: @"Popup triangle"] retain];
+        PopupTriangleSize = [PopupTriangleImage size];
+    }
     canChooseFiles = YES; canChooseDirectories = NO;
     [self setAlias: nil];
@@ -47,12 +55,6 @@
         [NSBezierPath strokeRect: NSInsetRect(boundsRect, 2, 2)];
     } else if (selectedAlias != nil && [self isEnabled]) {
-        static NSImage *popupTriangle = nil;
-        static NSSize imageSize;
-        if (popupTriangle == nil) {
-            popupTriangle = [[NSImage imageNamed: @"Popup triangle"] retain];
-            imageSize = [popupTriangle size];
-        }
         // equivalent to popup triangle location for large bezel in Carbon
-        [popupTriangle compositeToPoint: NSMakePoint(NSMaxX(boundsRect) - imageSize.width - 5, NSMaxY(boundsRect) - 5) operation: NSCompositeSourceOver];
+        [PopupTriangleImage compositeToPoint: NSMakePoint(NSMaxX(boundsRect) - PopupTriangleSize.width - 5, NSMaxY(boundsRect) - 5) operation: NSCompositeSourceOver];
     }
 }
@@ -130,5 +132,4 @@
         NSString *path = [alias fullPath];
         NSString *revealPath = nil;
-        NSString *targetName = [path lastPathComponent];
         NSMenu *menu = [[NSMenu alloc] initWithTitle: @""];
         NSFileManager *fmgr = [NSFileManager defaultManager];
@@ -136,5 +137,11 @@
         if (path != nil) { // can resolve alias
             [self setImage: [[NSWorkspace sharedWorkspace] iconForFile: path]];
-            [self setTitle: targetName];
+            {	// set image first so titleRectForBounds: returns the correct value
+                NSMutableString *title = [[fmgr displayNameAtPath: path] mutableCopy];
+                NSDictionary *fontAttributes = [[self attributedTitle] fontAttributesInRange: NSMakeRange(0, 0)];
+                [title truncateToWidth: [[self cell] titleRectForBounds: [self bounds]].size.width - PopupTriangleSize.width by: NSLineBreakByTruncatingMiddle withAttributes: fontAttributes];
+                [self setTitle: title];
+                [title release];
+            }
             do {
                 item = [menu addItemWithTitle: [fmgr displayNameAtPath: path]
Index: /trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRHistoryTrackingComboBox.m	(revision 53)
@@ -60,4 +60,5 @@
     NSString *newValue = [self stringValue];
     int oldIndex = [self indexOfItemWithObjectValue: newValue];
+    if ([newValue length] == 0) return YES; // donÕt save empty entries
     [self removeItemWithObjectValue: newValue];
     [self insertItemWithObjectValue: newValue atIndex: 0];
Index: /trunk/Cocoa/Pester/Source/NJRIntegerFilter.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRIntegerFilter.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRIntegerFilter.h	(revision 53)
@@ -7,5 +7,5 @@
 //
 
-#import <AppKit/AppKit.h>
+#import <Foundation/Foundation.h>
 
 
Index: /trunk/Cocoa/Pester/Source/NJRIntegerFilter.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRIntegerFilter.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRIntegerFilter.m	(revision 53)
@@ -7,6 +7,6 @@
 //
 
-// based on MyIntegerFilter
-// Copyright © 2001 Bill Cheeseman. All rights reserved.
+// based on MyIntegerFilter, later VRIntegerNumberFilter
+// Copyright © 2001-2002 Bill Cheeseman. All rights reserved.
 
 #import "NJRIntegerFilter.h"
@@ -14,20 +14,14 @@
 @implementation NJRIntegerFilter
 
-// Input filter
+// Input validation
 
-- (BOOL)isPartialStringValid:(NSString **)partialStringPtr proposedSelectedRange:(NSRangePointer)proposedSelRangePtr originalString:(NSString *)origString originalSelectedRange:(NSRange)origSelRange errorDescription:(NSString **)error {
-
-    // Override method to enable NSControl delegate method control:didFailToValidatePartialString:errorDescription: to
-    // reject invalid keypresses. Filters out keyboard input characters other than "1" .. "9".
+- (BOOL)isPartialStringValid:(NSString **)partialStringPtr proposedSelectedRange:(NSRangePointer)proposedSelRangePtr originalString:(NSString *)origString originalSelectedRange:(NSRange)origSelRange errorDescription:(NSString **)error;
+{
+    // Override method to enable NSControl delegate method control:didFailToValidatePartialString:errorDescription: to reject invalid keypresses. Filters out keyboard input characters other than 0..9.
     if ([[*partialStringPtr substringWithRange:NSMakeRange(origSelRange.location, (*proposedSelRangePtr).location - origSelRange.location)] rangeOfCharacterFromSet:[[NSCharacterSet decimalDigitCharacterSet] invertedSet] options:NSLiteralSearch].location != NSNotFound) {
-        *error = NSLocalizedString(@"Input is not an integer", @"Presented when user value not a numeric digit");
-        return NO; // Reject *partialStringPtr as typed, invoke delegate method
+        *error = NSLocalizedString(@"Input is not an integer.", @"Presented when user value not a numeric digit");
+        return NO; // Reject *partialStringPtr as typed, invoke delegate method for error handling
     }
-
-    if ([*partialStringPtr length] == 0) {
-        // Work around NSFormatter issue in Mac OS X 10.0.
-        [[[NSApp keyWindow] fieldEditor:NO forObject:nil] setSelectedRange:*proposedSelRangePtr];
-    }
-
+    *error = nil;
     return YES; // Accept *partialStringPtr as typed
 }
Index: /trunk/Cocoa/Pester/Source/NJRIntervalField.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRIntervalField.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NJRIntervalField.h	(revision 53)
@@ -0,0 +1,21 @@
+//
+//  NJRIntervalField.h
+//  Pester
+//
+//  Created by Nicholas Riley on Wed Dec 25 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface NJRIntervalField : NSTextField {
+    IBOutlet NSPopUpButton *intervalUnits;
+}
+
+- (NSTimeInterval)interval;
+- (BOOL)setInterval:(NSTimeInterval)interval; // returns false if out of range
+
+- (void)handleDidFailToFormatString:(NSString *)string errorDescription:(NSString *)error label:(NSString *)label;
+
+@end
Index: /trunk/Cocoa/Pester/Source/NJRIntervalField.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRIntervalField.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NJRIntervalField.m	(revision 53)
@@ -0,0 +1,154 @@
+//
+//  NJRIntervalField.m
+//  Pester
+//
+//  Created by Nicholas Riley on Wed Dec 25 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "NJRIntervalField.h"
+
+// XXX much implementation borrowed from DockCam, then factored; should replace DockCam interval selector with a NJRIntervalField at some point
+
+@implementation NJRIntervalField
+
+- (NSTimeInterval)interval;
+{
+    NSText *editor = [self currentEditor];
+    id obj = nil;
+    
+    if (editor != nil) {
+        NSString *stringValue = [editor string];
+        if (![[self formatter] getObjectValue: &obj forString: stringValue errorDescription: NULL])
+            return 0;
+    } else {
+        obj = self;
+    }
+    
+    return [obj intValue] * [[intervalUnits selectedItem] tag];
+}
+
+- (BOOL)setInterval:(NSTimeInterval)interval;
+{
+    // we assume that the tags are in ascending order in the array
+    NSEnumerator *e = [[intervalUnits itemArray] reverseObjectEnumerator];
+    NSMenuItem *i;
+    int multiplierTag;
+
+    while ( (i = [e nextObject]) != nil) {
+        multiplierTag = [i tag];
+        if (((int)interval % multiplierTag) == 0) {
+            NSFormatter *formatter = [self formatter];
+            int intervalValue = interval / multiplierTag;
+            if (formatter != nil) {
+                id ignored;
+                if (![formatter getObjectValue: &ignored forString: [formatter stringForObjectValue: [NSNumber numberWithInt: intervalValue]] errorDescription: NULL]) return NO;
+            }
+            [self setIntValue: intervalValue];
+            [intervalUnits selectItem: i];
+            return YES;
+        }
+    }
+    return NO;
+}
+
+- (BOOL)textView:(NSTextView *)textView shouldChangeTextInRange:(NSRange)range replacementString:(NSString *)string;
+{
+    unsigned length = [string length];
+    if (length != 0) {
+        unichar c;
+        int tag = -1;
+        c = [string characterAtIndex: length - 1];
+        switch (c) {
+            case 's': case 'S': tag = 1; break;
+            case 'm': case 'M': tag = 60; break;
+            case 'h': case 'H': tag = 60 * 60; break;
+            default: break;
+        }
+        if (tag != -1) [intervalUnits selectItemAtIndex: [intervalUnits indexOfItemWithTag: tag]];
+    }
+    return [super textView: textView shouldChangeTextInRange: range replacementString: string];
+}
+
+- (void)handleDidFailToFormatString:(NSString *)string errorDescription:(NSString *)error label:(NSString *)label;
+{
+    NSString *alertMessage;
+    NSString *alternateButtonString;
+    NSDecimalNumber *proposedValue;
+    NSDictionary *contextInfo;
+
+    NSString *alertInformation = [NSString localizedStringWithFormat:
+        NSLocalizedString(@"The %@ field must be set to a value between %@ and %@.",
+                          @"Informative text for alert posed by text field when invalid value entered"),
+        label, [[self formatter] minimum], [[self formatter] maximum]];
+    NSString *defaultButtonString = NSLocalizedString(@"Edit", @"Name of Edit button");
+    NSString *otherButtonString = NSLocalizedString(@"Cancel", @"Name of Cancel button");
+
+    if ([error isEqualToString:
+        NSLocalizedStringFromTableInBundle(@"Fell short of minimum", @"Formatter",
+                                           [NSBundle bundleForClass:[NSFormatter class]],
+                                           @"Presented when user value smaller than minimum")]) {
+        proposedValue = [[self formatter] minimum];
+        alertMessage = [NSString stringWithFormat:
+            NSLocalizedString(@"Ò%@Ó is too small for the %@ field.",
+                              @"Message text for alert posed by numeric field when too-small value entered"),
+            string, label];
+        alternateButtonString = [NSString localizedStringWithFormat:
+            NSLocalizedString(@"Set to %@",
+                              @"Name of alternate button for alert posed by numeric field when too-small value entered"),
+            proposedValue];
+    } else if ([error isEqualToString:
+        NSLocalizedStringFromTableInBundle(@"Maximum exceeded", @"Formatter",
+                                           [NSBundle bundleForClass:[NSFormatter class]],
+                                           @"Presented when user value larger than maximum")]) {
+        proposedValue = [[self formatter] maximum];
+        alertMessage = [NSString stringWithFormat:
+            NSLocalizedString(@"Ò%@Ó is too large for the %@ field.",
+                              @"Message text for alert posed by numeric field when too-large value entered"),
+            string, label];
+        alternateButtonString = [NSString localizedStringWithFormat:
+            NSLocalizedString(@"Set to %@",
+                              @"Name of alternate button for alert posed by numeric field when too-large value entered"),
+            proposedValue];
+    } else if ([error isEqualToString:
+        NSLocalizedStringFromTableInBundle(@"Invalid number", @"Formatter",
+                                           [NSBundle bundleForClass:[NSFormatter class]],
+                                           @"Presented when user typed illegal characters: no valid object")]) {
+        alertMessage = [NSString stringWithFormat:
+            NSLocalizedString(@"Ò%@Ó is not a valid entry for the %@ field.",
+                              @"Message text for alert posed by text field when invalid value entered"),
+            string, label];
+        alternateButtonString = nil;
+    }
+
+    contextInfo = [NSDictionary dictionaryWithObject: proposedValue forKey: @"proposedValue"];
+    [contextInfo retain];
+    NSBeep();
+    NSBeginAlertSheet(alertMessage, defaultButtonString, alternateButtonString, otherButtonString, [self window],
+                      self, @selector(validationFailedSheetDidEnd:returnCode:contextInfo:), NULL, contextInfo,
+                      alertInformation);
+}
+
+- (void)_propagateValidationChange;
+{
+    NSText *fieldEditor = [self currentEditor];
+    NSDictionary *userInfo = nil;
+    if (fieldEditor != nil) userInfo = [NSDictionary dictionaryWithObject: fieldEditor forKey: @"NSFieldEditor"];
+    [[NSNotificationCenter defaultCenter] postNotificationName: NSControlTextDidChangeNotification object: self userInfo: userInfo];
+    [self selectText: self];
+}
+
+- (void)validationFailedSheetDidEnd:(NSWindow *)sheet returnCode:(int)returnCode contextInfo:(void *)contextInfo {
+    // modal delegate callback method for NSBeginAlertSheet() function; called in the above method
+    if (returnCode == NSAlertOtherReturn) { // cancel
+        [self abortEditing]; // abort edit session and reinstate original value
+        [self _propagateValidationChange];
+    } else if (returnCode == NSAlertAlternateReturn) { // set to min/max/default value
+        [self setObjectValue: [(NSDictionary *)contextInfo objectForKey: @"proposedValue"]];
+        [self validateEditing];
+        [self _propagateValidationChange];
+    }
+    [(NSDictionary *)contextInfo release];
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.h	(revision 53)
@@ -22,5 +22,8 @@
 
 - (BDAlias *)selectedAlias;
+- (void)setAlias:(BDAlias *)alias;
+
 - (BOOL)canRepeat;
+
 - (IBAction)stopSoundPreview:(id)sender;
 
Index: /trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRQTMediaPopUpButton.m	(revision 53)
@@ -11,4 +11,10 @@
 #import "NSMovie-NJRExtensions.h"
 #import "NSImage-NJRExtensions.h"
+
+// XXX workaround for SoundFileManager log message in 10.2.3 and earlier
+#include <stdio.h>
+#include <unistd.h>
+#include <fcntl.h>
+// XXX end workaround
 
 static const int NJRQTMediaPopUpButtonMaxRecentItems = 10;
@@ -103,5 +109,5 @@
 #pragma mark initialize-release
 
-- (void)awakeFromNib;
+- (void)_setUp;
 {
     NSMenu *menu;
@@ -145,4 +151,20 @@
 }
 
+- (id)initWithFrame:(NSRect)frame;
+{
+    if ( (self = [super initWithFrame: frame]) != nil) {
+        [self _setUp];
+    }
+    return self;
+}
+
+- (id)initWithCoder:(NSCoder *)coder;
+{
+    if ( (self = [super initWithCoder: coder]) != nil) {
+        [self _setUp];
+    }
+    return self;
+}
+
 - (void)dealloc;
 {
@@ -171,4 +193,12 @@
 }
 
+- (void)setAlias:(BDAlias *)alias;
+{
+    [self _setAlias: alias];
+    if ([self _validateWithPreview: NO]) {
+        [self selectItem: [self _itemForAlias: selectedAlias]];
+    }
+}
+
 - (void)_setPath:(NSString *)path;
 {
@@ -186,5 +216,15 @@
     // [self _validateRecentMedia];
     path = [alias fullPath];
-    sf = [[SoundFileManager sharedSoundFileManager] soundFileFromPath: path];
+    {   // XXX suppress log message from Apple's code:
+        // 2002-12-14 14:09:58.740 Pester[26529] Could not find sound type for directory /Users/nicholas/Desktop
+        int errfd = dup(STDERR_FILENO), nullfd = open("/dev/null", O_WRONLY, 0);
+        // need to have something open in STDERR_FILENO because if it isn't,
+        // NSLog will log to /dev/console
+        dup2(nullfd, STDERR_FILENO);
+        close(nullfd);
+        sf = [[SoundFileManager sharedSoundFileManager] soundFileFromPath: path];
+        dup2(errfd, STDERR_FILENO);
+        close(errfd);
+    }
     // NSLog(@"_itemForAlias: %@", path);
 
@@ -250,10 +290,10 @@
             [preview setMovie: nil];
             if (movie == nil) {
-                NSBeginAlertSheet(@"Format not recognized", @"OK", nil, nil, [self window], nil, nil, nil, nil, @"The item you selected isnÕt a sound or movie recognized by QuickTime.  Please select a different item.");
+                NSBeginAlertSheet(@"Format not recognized", nil, nil, nil, [self window], nil, nil, nil, nil, @"The item you selected isnÕt a sound or movie recognized by QuickTime.  Please select a different item.");
                 [self _invalidateSelection];
                 return NO;
             }
             if (![movie hasAudio] && ![movie hasVideo]) {
-                NSBeginAlertSheet(@"No video or audio", @"OK", nil, nil, [self window], nil, nil, nil, nil, @"Ò%@Ó contains neither audio nor video content playable by QuickTime.  Please select a different item.", [[NSFileManager defaultManager] displayNameAtPath: [selectedAlias fullPath]]);
+                NSBeginAlertSheet(@"No video or audio", nil, nil, nil, [self window], nil, nil, nil, nil, @"Ò%@Ó contains neither audio nor video content playable by QuickTime.  Please select a different item.", [[NSFileManager defaultManager] displayNameAtPath: [selectedAlias fullPath]]);
                 [self _invalidateSelection];
                 [movie release];
@@ -262,5 +302,5 @@
         }
         [movie release];
-        [preview start: self];
+        if (doPreview) [preview start: self];
     }
     [[NSNotificationCenter defaultCenter] postNotificationName: NJRQTMediaPopUpButtonMovieChangedNotification object: self];
Index: /trunk/Cocoa/Pester/Source/NJRTableDelegate.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRTableDelegate.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRTableDelegate.m	(revision 53)
@@ -179,5 +179,5 @@
             NSRect columnRect = [superview convertRect: [tableView rectOfColumn: [tableView columnWithIdentifier: sortingKey]] fromView: tableView];
             // XXX support horizontal scroll bar/clipping (not for Pester, but eventually)
-            NSRect tableScrollFrame = [[tableView enclosingScrollView] frame];
+            // NSRect tableScrollFrame = [[tableView enclosingScrollView] frame];
             NSRect selectFrame = [typeSelectControl frame];
             [superview setNeedsDisplayInRect: selectFrame]; // fix artifacts caused by moving view
Index: /trunk/Cocoa/Pester/Source/NJRTableView.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRTableView.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRTableView.h	(revision 53)
@@ -11,4 +11,5 @@
 
 @interface NJRTableView : NSTableView {
+    NSMutableDictionary *toolTipRegionList;
     NSMutableString *typed;
     IBOutlet id typeSelectDisplay;
@@ -29,4 +30,5 @@
 
 - (void)removeSelectedRowsFromTableView:(NSTableView *)tableView;
+- (NSString *)tableView:(NSTableView *)aTableView toolTipForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex;
 
 @end
Index: /trunk/Cocoa/Pester/Source/NJRTableView.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRTableView.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRTableView.m	(revision 53)
@@ -17,4 +17,65 @@
 
 @implementation NJRTableView
+
+- (id)initWithCoder:(NSCoder *)aDecoder;
+{
+    if ( (self = [super initWithCoder: aDecoder]) != nil) {
+        toolTipRegionList = [[NSMutableDictionary alloc] initWithCapacity: 20];
+    }
+    return self;
+}
+
+- (void)dealloc;
+{
+    [toolTipRegionList release];
+    [super dealloc];
+}
+
+#pragma mark tool tips
+
+- (void)reloadData;
+{
+    [toolTipRegionList removeAllObjects];
+    [self removeAllToolTips];
+    [super reloadData];
+}
+
+- (void)noteNumberOfRowsChanged;
+{
+    [toolTipRegionList removeAllObjects];
+    [self removeAllToolTips];
+    [super noteNumberOfRowsChanged];
+}
+
+- (NSString *)_keyForColumn:(int)columnIndex row:(int)rowIndex;
+{
+    return [NSString stringWithFormat:@"%d,%d", rowIndex, columnIndex];
+}
+
+- (NSString *)view:(NSView *)view stringForToolTip:(NSToolTipTag)tag point:(NSPoint)point userData:(void *)data;
+{
+    // ask our data source for the tool tip
+    if ([[self dataSource] respondsToSelector: @selector(tableView:toolTipForTableColumn:row:)]) {
+        if ([self rowAtPoint: point] >= 0) return [[self dataSource] tableView: self toolTipForTableColumn: [[self tableColumns] objectAtIndex: [self columnAtPoint: point]] row: [self rowAtPoint: point]];
+    }
+    return nil;
+}
+
+- (NSRect)frameOfCellAtColumn:(int)columnIndex row:(int)rowIndex;
+{
+    // this cell is apparently displayed, so we need to add a region for it
+    NSNumber *toolTipTag;
+    NSRect result = [super frameOfCellAtColumn: columnIndex row: rowIndex];
+    // check if cell is already in the list
+    NSString *cellKey = [self _keyForColumn: columnIndex row: rowIndex];
+    // remove old region
+    if (toolTipTag = [toolTipRegionList objectForKey: cellKey])
+        [self removeToolTip: [toolTipTag intValue]];
+    // add new region
+    [toolTipRegionList setObject: [NSNumber numberWithInt: [self addToolTipRect: result owner: self userData: cellKey]] forKey: cellKey];
+    return [super frameOfCellAtColumn: columnIndex row: rowIndex];
+}
+
+#pragma mark type selection
 
 - (id)typeSelectDisplay;
Index: /trunk/Cocoa/Pester/Source/NJRUnfocusableMovieView.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRUnfocusableMovieView.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NJRUnfocusableMovieView.h	(revision 53)
@@ -0,0 +1,16 @@
+//
+//  NJRUnfocusableMovieView.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Dec 15 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface NJRUnfocusableMovieView : NSMovieView {
+
+}
+
+@end
